#!/bin/bash
# Script to install the demo-stm32mp1 package

if [ -r "$PLATFORM_LOC/scripts/utils.sh" ]; then
	source "$PLATFORM_LOC/scripts/utils.sh"
else
	source "$script_lib_dir/utils.sh"
fi

SRC_NAME=${SRC_LOC%.tar.*}
SRC_NAME=${SRC_NAME##*/}

if [ "$SRC_NAME" = "empty" ]; then
	exit 0
fi

S=${PWD}
D=${installDir}
bindir=/usr/bin
datadir=/usr/share
sysconfdir=/etc
rootdir=/root

do_buildstep_prepend

log_exec rm -rf $SRC_NAME

for src in "$DOWNLOAD_LOC/$(basename $SRC_LOC)" "$DOWNLOAD_LOC/$(basename $SRC_LOC).tar.*"; do
	if [ -r "$src" ]; then
		log_exec tar xf "$src"
		break
	fi
done

log_exec install -dm755 ${D}${bindir}
log_exec install -dm755 ${D}${rootdir}
log_exec install -dm755 ${D}${sysconfdir}/init.d
log_exec install -dm755 ${D}${sysconfdir}/xdg/weston
log_exec install -dm755 ${D}${datadir}/weston
log_exec install -dm755 ${D}${datadir}/X11/xkb

log_exec touch ${D}${datadir}/X11/xkb/empty

# Install applications
log_exec install -Dm755 "${S}/applications/fork_gstreamer" "${D}${bindir}/fork_gstreamer"
log_exec install -Dm755 "${S}/applications/qtdemo_arm32" "${D}${bindir}/qtdemo_arm32"

# Install startup scripts
log_exec install -Dm755 "${S}/init_modules" "${D}${sysconfdir}/init.d/S03modules"
log_exec install -Dm755 "${S}/init_weston" "${D}${sysconfdir}/init.d/S30weston"
log_exec install -Dm755 "${S}/init_goodix" "${D}${sysconfdir}/init.d/S70goodix"

log_exec install -Dm655 "${S}/modules" "${D}${sysconfdir}/modules"
log_exec install -Dm666 "${S}/weston.ini" "${D}${sysconfdir}/xdg/weston/weston.ini"

# Install multimedia contents
log_exec cp -r ${S}/contents ${D}${rootdir}
log_exec ln -snr ${D}${rootdir}/contents/videos/small.mp4 ${D}${rootdir}/gstreamer.mp4
log_exec install -Dm655 "${D}${rootdir}/contents/images/ac6.png" "${D}${datadir}/weston/ac6.png"
log_exec install -Dm655 "${D}${rootdir}/contents/images/egl.png" "${D}${datadir}/weston/egl.png"
log_exec install -Dm655 "${D}${rootdir}/contents/images/flower.png" "${D}${datadir}/weston/flower.png"
log_exec install -Dm655 "${D}${rootdir}/contents/images/gstreamer.png" "${D}${datadir}/weston/gstreamer.png"
log_exec install -Dm655 "${D}${rootdir}/contents/images/qt.png" "${D}${datadir}/weston/qt.png"

do_buildstep_append
