#!/bin/bash
# Script to install a prebuilt package

if [ -r "$PLATFORM_LOC/scripts/utils.sh" ]; then
	source "$PLATFORM_LOC/scripts/utils.sh"
else
	source "$script_lib_dir/utils.sh"
fi

rootdir=/root

do_buildstep_prepend

set -vx
for src in ${srcDir}/*.tar ${srcDir}/*.tar.*; do
	if [ -r "$src" ]; then
		log_exec tar xf "$src"
		break
	fi
done

log_exec install -dm755 ${installDir}${bindir}
log_exec install -dm755 ${installDir}${rootdir}
log_exec install -dm755 ${installDir}${rootdir}/contents/videos

for appFile in ${srcDir}/applications/*; do
	log_exec install -Dm755 "${appFile}" "${installDir}${bindir}/$(basename ${appFile})" 
done

for cascadeFile in ${srcDir}/resources/*.xml; do
	log_exec install -Dm644 "${cascadeFile}" "${installDir}${datadir}/OpenCV/haarcascades/$(basename ${cascadeFile})"
done

log_exec install -Dm644 "${srcDir}/contents/people.mp4" "${installDir}${rootdir}/contents/videos/people.mp4"
log_exec install -Dm644 "${srcDir}/contents/slap.mp4" "${installDir}${rootdir}/contents/videos/slap.mp4"
log_exec ln -nfs "${installDir}${rootdir}/contents/videos/people.mp4" "${installDir}${rootdir}/contents/videos/opencv.mp4"
set +vx

do_buildstep_append
