#!/bin/bash
# Script to install the demo-stm32mp1 package

if [ -r "$PLATFORM_LOC/scripts/utils.sh" ]; then
	source "$PLATFORM_LOC/scripts/utils.sh"
else
	source "$script_lib_dir/utils.sh"
fi

rootdir=/root

do_buildstep_prepend

for src in ${srcDir}/*.tar ${srcDir}/*.tar.*; do
	if [ -r "$src" ]; then
		log_exec tar xf "$src"
		break
	fi
done

log_exec install -dm755 ${installDir}${bindir}
log_exec install -dm755 ${installDir}${rootdir}
log_exec install -dm755 ${installDir}${sysconfdir}/init.d
log_exec install -dm755 ${installDir}${sysconfdir}/xdg/weston
log_exec install -dm755 ${installDir}${datadir}/weston
log_exec install -dm755 ${installDir}${datadir}/X11/xkb

log_exec touch ${installDir}${datadir}/X11/xkb/empty

# Install applications
log_exec install -Dm755 "${srcDir}/applications/fork_gstreamer" "${installDir}${bindir}/fork_gstreamer"
log_exec install -Dm755 "${srcDir}/applications/qtdemo_arm32" "${installDir}${bindir}/qtdemo_arm32"

# Install startup scripts
log_exec install -Dm755 "${srcDir}/init_modules" "${installDir}${sysconfdir}/init.d/S03modules"
log_exec install -Dm755 "${srcDir}/init_weston" "${installDir}${sysconfdir}/init.d/S30weston"
log_exec install -Dm755 "${srcDir}/init_goodix" "${installDir}${sysconfdir}/init.d/S70goodix"

log_exec install -Dm655 "${srcDir}/modules" "${installDir}${sysconfdir}/modules"
log_exec install -Dm666 "${srcDir}/weston.ini" "${installDir}${sysconfdir}/xdg/weston/weston.ini"

# Install multimedia contents
log_exec cp -r ${srcDir}/contents ${installDir}${rootdir}
log_exec ln -snr ${installDir}${rootdir}/contents/videos/small.mp4 ${installDir}${rootdir}/gstreamer.mp4
log_exec install -Dm655 "${installDir}${rootdir}/contents/images/ac6.png" "${installDir}${datadir}/weston/ac6.png"
log_exec install -Dm655 "${installDir}${rootdir}/contents/images/egl.png" "${installDir}${datadir}/weston/egl.png"
log_exec install -Dm655 "${installDir}${rootdir}/contents/images/flower.png" "${installDir}${datadir}/weston/flower.png"
log_exec install -Dm655 "${installDir}${rootdir}/contents/images/gstreamer.png" "${installDir}${datadir}/weston/gstreamer.png"
log_exec install -Dm655 "${installDir}${rootdir}/contents/images/qt.png" "${installDir}${datadir}/weston/qt.png"

do_buildstep_append