#!/bin/bash
# Script to configure u-boot

if [ -r "$PLATFORM_LOC/scripts/utils.sh" ]; then
	source "$PLATFORM_LOC/scripts/utils.sh"
else
	source "$script_lib_dir/utils.sh"
fi

CROSS_COMPILE=${NATIVE_SYSROOT_LOC}/${compiler_loc%/}/usr/bin/${compiler_prefix}- 

do_buildstep_prepend

if [ ! -d "$buildDir" ]; then
	log_exec mkdir -p $buildDir
fi

if [ "$srcDir" != "$buildDir" ] && [ -f "$srcDir/default.config" ] && [ ! -f "$buildDir/.config" ]; then
	log_exec cp "$srcDir/default.config" "$buildDir/.config"
fi

log_exec make -C $srcDir HOSTCC=${BUILD_CC}  CROSS_COMPILE=${CROSS_COMPILE} O=$buildDir oldnoconfig

do_buildstep_append
