#!/bin/bash
# Script to run make install with input target and arguments

if [ -r "$PLATFORM_LOC/scripts/utils.sh" ]; then
	source "$PLATFORM_LOC/scripts/utils.sh"
else
	source "$script_lib_dir/utils.sh"
fi

bootDir=${installDir}/boot
SPL_BINARY_STM32=spl/u-boot-spl.stm32

do_buildstep_prepend

log_exec install -d ${bootDir}
log_exec install -m 644 ${buildDir}/u-boot.* ${bootDir}
log_exec install -m 644 ${buildDir}/u-boot-*.* ${bootDir}

log_exec install -d ${bootDir}/spl
log_exec install -m 644 ${buildDir}/spl/u-boot.* ${bootDir}/spl
log_exec install -m 644 ${buildDir}/spl/u-boot-*.* ${bootDir}/spl

# As soon as SPL binary exists, copy it with specific binary_type name
# This allow to mix u-boot configuration, with and without SPL
if [ -f ${buildDir}/${SPL_BINARY_STM32} ]; then
	log_exec install -m 644 ${buildDir}/${SPL_BINARY_STM32} ${bootDir}/u-boot-spl.stm32
fi

do_buildstep_append
